
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>阿里巴巴开源Java编码规范背后的故事 / iVAN</title>

    <meta name="description" content="阿里巴巴开源Java编码规范背后的故事 (作者:无独 | 校对:孤尽) &lt;阿里巴巴Java开发手册&gt;(下称&lt;手册&gt;)凝聚了阿里集团很多同学的知识智慧和经验,这些经验甚至是用血淋淋的故障换来的,希望前车之鉴,后车之师,能够帮助更多的开发者少踩坑,杜绝踩重复的坑.  手册下载:https://yq.aliyun.com/articles/69327 此手册从构思到现在的最新版本,历时一年半,历经无数次内部针锋相对的讨论,迭代105次.可以说手册中每一个条目的背后,都有一个很长.很精彩的故事.为了让广大开发者更加深入 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">阿里巴巴开源Java编码规范背后的故事</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>（作者：无独 | 校对：孤尽）</p>
<p>《阿里巴巴Java开发手册》（下称《手册》）凝聚了阿里集团很多同学的知识智慧和经验，这些经验甚至是用血淋淋的故障换来的，希望前车之鉴，后车之师，能够帮助更多的开发者少踩坑，杜绝踩重复的坑。 </p>
<p>手册下载：</p>
<p>此手册从构思到现在的最新版本，历时一年半，历经无数次内部针锋相对的讨论，迭代105次。可以说手册中每一个条目的背后，都有一个很长、很精彩的故事。为了让广大开发者更加深入地了解到项目组的初衷，项目组第一次公开谈一些手册背后的故事。</p>
<h3>为何叫《Java开发手册》？</h3>
<p>第一、本手册主要是面向Java开发群体，Java做为面向对象语言，在业界的生命力还是非常强大的，技术生态丰富，框架结构成熟，经历了超高并发的“双十一”实战考验，阿里真诚地想把多年的Java技术积累回馈给Java开发者 社区。</p>
<p>第二、它是一个广义的编码规范， 一个随时可以查阅的技术参考，在手册中可以找到很多的技术规范、最佳实践，避坑指南等。</p>
<h3>手册内容为何引入数据库、安全、服务器等知识？</h3>
<p>现代软件行业的高速发展对于开发者的综合素质要求越来越高，因为不仅是编程知识，其它维度的知识结构也会影响到软件的最终交付质量。比如：数据库的表结构和索引设计缺陷可能带来软件上的架构缺陷或性能风险；工程结构混乱导致维护困难；没有鉴权的漏洞代码被黑客攻击等等。</p>
<p>所以手册以Java开发者为中心视角，划分为编程规约、异常日志规约、MySQL规约、工程规约、安全规约五大块。那么衍生的问题是为什么我们提到的这些看似与编码毫无关系的内容，有人说，仅安全规约如果扩展开来可以是上百页的资料，不知道写在《手册》里的意义何在，我们的答案是，手册关注的是与开发紧密相关的知识点，试问一个不知道水平权限校验的Java开发者，会是一个合格的程序员吗？《手册》不是提倡大家深究所有的知识点而成为安全专家、运维专家，而是关注在编码相关的生态知识上。</p>
<h3>约束力等级为何是三级？</h3>
<p>《手册》根据约束力强弱及故障敏感性，规约依次分为强制、推荐、参考三大类。强制是一种指令型的，是协作的Gap，或是故障的痛点；而推荐，希望这样做是一件好事，大家都这样做，结构更清晰，协作更高效，但是不这样做也不会死。而参考分成两种情况：第一种是无法用代码量化的描述，提倡什么什么样的做法，如索引的创建索引时，宁滥勿缺的错误做法；第二种是真心觉得或左或右都可以，只是有倾向于一种，这个自由度由开发者自己把握。</p>
<p>扩展的说明、正例、反例用来表达什么。如果只是冷冰冰的条目，对于阅读者理解成本和记忆成本都是很大的挑战，《手册》希望阅读者能够非常舒心地看完整个文档，掩卷遐思，亦有所得。具体来说， “说明”是对内容做了引申和解释，为求知其然；“正例”提倡什么样的编码和实现方式，推荐做法的其中之一；“反例”说明需要提防的雷区，以及真实的错误案例，让人知其不然。</p>
<p>最后，《手册》的愿景是码出质量、码出高效，即代码的字里行间如何提升系统的质量，如何提升协作的高效性。 我们提倡算法效率和架构扩展的个性化，而不是代码风格随意化，尽量减少没有营养的“圣战”，如：4个空格、单行语句换行等。程序员是天生幻想创造个性化作品的艺术家，变着法子想着要如何与众不同，最好代码只有自己能够看懂，只有自己能够维护。</p>
<h3>码出质量、码出高效</h3>
<p>真正的艺术家是个性独立、张扬文化的群体，他们之间不需要协同工作，大家很少见过书法，画画、雕塑是一个团队协作来创作完成的，但是程序员这个工种，天生需要团队协作，而协作的正能量要放在问题的有效讨论和快速解决上， 个性化应尽量表现在代码质量和算法效率的提升上，而不是对于合作规范上纠缠不休的争论。再者，公司是请程序员来产出实际价值的，而不是经常消耗时间为几个空格的事情争得脸红脖子粗的。有时候，就是一个规定，大家这么做了，协作效率自然就提升了，正所谓无规矩不成方圆，无规范难以协作。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 15:35:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9e%b6%e6%9e%84/" title="架构">架构</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e5%b7%b4%e5%b7%b4/" title="阿里巴巴">阿里巴巴</a>, <a href="https://www.iamivan.net/tag/%e5%ae%89%e5%85%a8/" title="安全">安全</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%a9%ba%e6%a0%bc/" title="空格">空格</a>, <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1/" title="面向对象">面向对象</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f%e5%91%98/" title="程序员">程序员</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a0%81%e8%a7%84%e8%8c%83/" title="编码规范">编码规范</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b%e8%a7%84%e5%88%99/" title="编程规则">编程规则</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>阿里巴巴开源Java编码规范背后的故事的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Ng4az.html" rel="bookmark">资料推荐--Google Java编码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前已经推荐过Google的Java编码规范英文版了: http://google-styleguide.googlecode.com/svn/trunk/javaguide.html 虽然这篇文章的英文很简单,但是最近发现有人翻译了这篇文章,所以专门写一篇文章推荐一下: http://hawstein.com/posts/google-java-style.html   同时为了避免原始文章丢失,所以转了一下: 作者:Hawstein 出处:http://hawstein.com/posts/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWnDBp.html" rel="bookmark">【Java编码规范】《阿里巴巴Java开发手册》终极版更新，在线代码检测及IDE插件发布</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        -------------- 2017.10.14更新 -------------- &lt;阿里巴巴Java开发手册(终极版)&gt;正式发布,这是史上内容最全.修正最为彻底的一个版本,并且增加了单元测试规约内容,这也是阿里官方对外发布的最后一个PDF版本,值得收藏.   &lt;阿里巴巴Java开发手册&gt;是阿里内部Java工程师所遵循的开发规范,涵盖编程规约.单元测试规约.异常日志规约.MySQL规约.工程规约.安全规约等,这是近万名阿里Java技术精英的经验总结,并经历了多次大			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrqW6vb.html" rel="bookmark">java main方法背后的故事？（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jvm java 看似一种语言,实则一个巨大的体系的王国,开发这么多年了,还是没有搞懂,我以为我懂了,可是过了一段时间又忘了,所以说还是没懂 1.main方法说起 编译完我们的java文件后,需要有个一含有main方法的类,java 命令将指示操作系统启动一个jvm进程 这个jvm进程启动后,寻找那个main地方开始执行程序 java [JVM_Options] ClassName_with_main [args_separate_space] main方法的签名必须是 pubic static			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpPLvlp.html" rel="bookmark">Java 程序编码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编码|程序|规范 Java 程序编码规范 李小敏www.yway.com 软件工程师2000年12月内容: 命名惯例 Java文件样式 代码编写格式 程序编写 编程技巧 Swing 调试 性能 可移植性 参考资料 作者简介    所有的程序开发手册都包含了各种规则.一些习惯自由程序人员可能对这些规则很不适应,但是在多个开发人员共同写作的情况下,这些规则是必需的.这不仅仅是为了开发效率来考虑,而且也是为了后期维护考虑.命名规范 定义这个规范的目的是让项目中所有的文档都看起来像一个人写的,增加可读性			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpP1P1z.html" rel="bookmark">JavaScript编程语言的编码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网页制作Webjx文章简介:对于熟悉 C/C++ 或 Java 语言的工程师来说,JavaScript 显得灵活,简单易懂,对代码的格式的要求也相对松散.很容易学习,并运用到自己的代码中.也正因为这样,JavaScript 的编码规范也往往被轻视,开发过程中修修补补,最终也就演变成为后续维护人员的恶梦.软件存在 对于熟悉 C/C++ 或 Java 语言的工程师来说,JavaScript 显得灵活,简单易懂,对代码的格式的要求也相对松散.很容易学习,并运用到自己的代码中.也正因为这样,JavaSc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxyQPp.html" rel="bookmark">JSP 编码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|编码|规范 .整个jsp/jsp bean表示层应当尽可能的瘦和简单化. .牢记大多数的JSP都应当是只读的视图,而由页面bean来提供模型. .应当一起设计JSP和JSP bean .在尽可能合理的情况下,把业务逻辑从JSP中移走.具体于HTTP的逻辑(如,对Cookie的处理)属于bean或支持类中,而不是JSP中. .尽量把条件逻辑放在控制器中而不是放在视图中. .为JSP.包含的文件.JSP Bean和实现扩展标记的类使用遵循标准的命名惯例.如:        jsp控制器   x			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwl29vb.html" rel="bookmark">javascript中的编程语言如何编码规范</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于熟悉 C/C++ 或 Java 语言的工程师来说,javascript 显得灵活,简单易懂,对代码的格式的要求也相对松散.很容易学习,并运用到自己的代码中.也正因为这样,javascript 的编码规范也往往被轻视,开发过程中修修补补,最终也就演变成为后续维护人员的恶梦.软件存在的长期价值直接与编码的质量成比例.编码规范能帮助我们降低编程中不必要的麻烦.而 javascript 代码是直接发送给客户浏览器的,直接与客户见面,编码的质量更应该受到关注. 本文浅谈 javascript 编程中关			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6exxgb.html" rel="bookmark">浅谈JavaScript编程语言的编码规范&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 编程语言作为最流行的客户端脚本语言,早已被众多 Web 开发人员所熟悉.随着 Web2.0 时代的到来和 Ajax 技术的广泛应用,JavaScript 也逐渐吸引着更多的视线.工作中要求越多的是对 JavaScript 语言的深入学习,灵活运用,和对编码质量的保证. 对于熟悉 C/C++ 或 Java 语言的工程师来说,JavaScript 显得灵活,简单易懂,对代码的格式的要求也相对松散.很容易学习,并运用到自己的代码中.也正因为这样,JavaScript 的编码规范也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6X9jz.html" rel="bookmark">Java 注释规范详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Java 的编写过程中我们需要对一些程序进行注释,除了自己方便阅读,更为别人更好理解自己的程序,所以我们需要进行一些注释,可以是编程思路或者是程序的作用,总而言之就是方便自己他人更好的阅读. 注释类型 Java 有两类注释: implementation comments(实现注释)和 documentation comments(文档注释). 实现注释常见于 C++,使用 /*...*/,和 //.文档注释 (也称为&quot;doc comments&quot;) 是 Java 独有的,使用 /*			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyw63b.html" rel="bookmark" class="title">Oracle Compile 编译无效对象&lpar;ORA-04063&colon; package body</a>
					<div>
						使用AUTOTRACE 前要做好准备工作 创建角色Plustrace SQL&gt;        @?/sqlplus/admin/plustrce.sql 将Plustrace角色授于要执行AUT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91qjRM.html" rel="bookmark" class="title">Java编程那些事儿23&mdash;逻辑运算符</a>
					<div>
						4.3 逻辑运算符 逻辑运算符是指进行逻辑运算的符号.逻辑运算主要包括与(and).或(or)和非(not)三种,在程序中主要用来连接多个条件,从而形成更加复杂的条件. 逻辑运算符的运算结果是bool ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPRyoz.html" rel="bookmark" class="title">JAVA技术专题综述之构造方法篇</a>
					<div>
						类的继承机制使得子类可以使用父类的功能(即代码),并且子类也具有父类的类型.下面介绍类在继承关系上的初始化的顺序问题. 示例1: class SuperClass { SuperClass() { S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY212lp.html" rel="bookmark" class="title">天猫2015新版设计点评</a>
					<div>
						  又来了!那个老点评京东天猫的人又来了! 貌似是2周前,发现了天猫改版了,然后又同学呼唤我:&quot;阿门,天猫改版了,赶紧出文章啊!&quot;唉我去!貌似我成了京东天猫改版后的标配点评了,既然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrklPp.html" rel="bookmark" class="title">Fireworks如何快速给人像调色</a>
					<div>
						  大家都习惯性的使用美图秀秀,Photoshop来处理图片,其实大家不知道的是有时用Fireworks就可以快速的处理图片,今天小编就给大家讲讲如何用Fireworks快速给人像调色吧. 在Fire ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBgqOz.html" rel="bookmark" class="title">iOS照片传到苹果电脑Mac的技巧</a>
					<div>
						  如果你想将 iOS 设备相机胶卷中的照片快速传到 Mac 的话,你可以借助 OS X 内置的应用图像捕捉轻松完成.如果你不习惯使用 iCloud 的话,当你想批量移动和删除 iPhone 或 iP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXj4gLb.html" rel="bookmark" class="title">android 中opengl画正方体，其顶底坐标还有索引是怎么计算和定义的？</a>
					<div>
						问题描述 android 中opengl画正方体,其顶底坐标还有索引是怎么计算和定义的? 能不能给个具体例子 ,详细说明,顺时针逆时针还是索引法?以及坐标旋转方法.不用给我讲很多例子 ,只用搞懂一种做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72N9Xp.html" rel="bookmark" class="title">WordPress和github page的选择和搭建</a>
					<div>
						搭建博客时对wordpress和github page进行了简单的对比,最终选择了wp. 这里就简单对比下wp和gp的优缺点及搭建过程简介.主要比较方面包括搭建复杂度.对域名空间要求.写博客的便捷程度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwPaep.html" rel="bookmark" class="title">Jmeter基础之---jmeter基础概念</a>
					<div>
						JMeter 介绍: 一个非常优秀的开源的性能测试工具.   优点:你用着用着就会发现它的重多优点,当然不足点也会呈现出来.   从性能工具的原理划分: Jmeter工具和其他性能工具在原理上完全一致 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVN8ZYz.html" rel="bookmark" class="title">项目3：PHP抽奖程序 ，抽奖规则代码 分时间段</a>
					<div>
						抽奖概率为:奖品总数为概率 =================================== 项目3 抽奖程序 分时间段 ===================================  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamw1Jb.html" rel="bookmark" class="title">Response&period;AddHeader使用实例收集 如何做下载，下载中文显示乱码怎么办 ContentType类型大全</a>
					<div>
						非常有用的文章~!~!忘记的时候可以来查找一下．．． 文件下载,指定默认名srxljl Response.AddHeader(&quot;content-type&quot;,&quot;applic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBKelb.html" rel="bookmark" class="title">携程旅行网当选&OpenCurlyDoubleQuote;中国最佳差旅管理公司&rdquo;</a>
					<div>
						和大家分享一个好消息--9月7日,权威旅游媒体&lt;TravelWeeklyChina 旅讯&gt;在北京揭晓了&quot;2009http://www.aliyun.com/zixun/aggre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgAQOb.html" rel="bookmark" class="title">app-android activity切换动画和墙纸冲突</a>
					<div>
						问题描述 android activity切换动画和墙纸冲突 主题里面设置了属性true 的时候,使用overridePendingTransition(app_in,app_exit); app_e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBGK8b.html" rel="bookmark" class="title">JavaScript中setMonth&lpar;&rpar;方法的使用详解&lowbar;基础知识</a>
					<div>
						 javascript Date.setMonth()方法按照本地时间设置每月指定日期.语法 Date.setMonth(monthValue[, dayValue]) 注:括号内外观和数据是可选的  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RjQJz.html" rel="bookmark" class="title">Python爆红的六大原因</a>
					<div>
						无论你是否清楚这个事实,Python实际上已经不是一门年轻的编程语言了.虽然它也不如其它一些语言那么年长,但它仍然比大部分人所想的要更老一些.它第一次发布的时间是在1991年,虽然这些年它也经历了相当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjaRwM.html" rel="bookmark" class="title">俄干涉美大选最新证据：APT28向数千个目标发送上万个钓鱼链接</a>
					<div>
						去年美国大选以来,美国媒体一直在指责俄干涉美国大选一事.三月底,FBI宣布展开关于俄罗斯对2016美国大选影响的调查.最新证据表明,俄罗斯在大规模的黑客行动中,曾试图通过19,315个网络钓鱼链接攻击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7qv2z.html" rel="bookmark" class="title">如何获取IP-pbx交换机上面的数据制作一个计费系统</a>
					<div>
						问题描述 怎么用C#做一个获取交换机上面的信息进行计费是不是用rawsocket截获数据包但是那具体的怎么做到在窗体上查询通话记录不知道能否帮我解释清楚点或者给个源代码或实例谢谢! 解决方案 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg0e4M.html" rel="bookmark" class="title">控制情绪和欲望，宁静致远</a>
					<div>
						        今天元旦,深圳风和日丽,气温最高超过了二十度,还是很舒服的一个温度.早上7点过就醒了,反思了2015,自己是不是懒了?是忙吗?那哪一年不忙?先回顾一下2015,这一年在CSDN才写了3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBnvqz.html" rel="bookmark" class="title">像这样多层if嵌套的代码如何优化</a>
					<div>
						问题描述 感觉自己看起来都费劲( ⊙ o ⊙ ),public String login() {boolean loginpass = false;Pckey pckey = null;int val ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLlxYM.html" rel="bookmark" class="title">让Word&OpenCurlyDoubleQuote;图片&rdquo;自由移动</a>
					<div>
						在用Word 2000编辑文件时,如果你 里面有图片或剪贴画,你会发现无论是水平.上下.斜向移动都不是一件容易的事,更 不用说把几个图片(或剪贴画)组合在一起和把几个图片(或剪贴画)任意调换摆放位置及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXVJQb.html" rel="bookmark" class="title">直销银行纷纷上线 金融策略各有千秋</a>
					<div>
						近日,南京银行直销银行&quot;你好银行&quot;低调上线试运行.最新消息称,南京银行直销银行首期推出的主打产品&quot;鑫元货币A&quot;的7日年化收益率为4.09%,这与其他银行系货币基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqxayb.html" rel="bookmark" class="title">暴雪承认《暗黑3》缺乏耐玩度</a>
					<div>
						很少有游戏厂商愿意站出来说&quot;我们的游戏还不够好&quot;,但这一次,暴雪对&lt;http://www.aliyun.com/zixun/aggregation/29993.html&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6dZqM.html" rel="bookmark" class="title">电影网站优化之域名、空间、程序的选择</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 大家好,对于上次给大家分享的一起见 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWNGez.html" rel="bookmark" class="title">&period;net&comma;js捕捉文本框回车键事件的小例子&lpar;兼容多浏览器&rpar;&lowbar;javascript技巧</a>
					<div>
						js: 复制代码 代码如下: function bubufx_enterpress(e) {         var keynum;           if (window.event) // IE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlAo0p.html" rel="bookmark" class="title">通过批处理调用SQL的方法&lpar;osql&rpar;&lowbar;DOS&sol;BAT</a>
					<div>
						osql /U alma /P /i stores.bat (stores.bat中包含update ,delete语句,不过,不需要使用GO) --------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLGPBM.html" rel="bookmark" class="title">CorelDRAW中如何设置名片的教程</a>
					<div>
						名片设计中,图案设计是一个重要环节,图案设计的成功与否直接影响到名片的视觉效果.以下步骤教您如何在 CorelDRAW X7软件中制作名片. 1.执行&quot;文件&quot;→&quot;新建命令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY8q8b.html" rel="bookmark" class="title">关于Hibernate更新的问题</a>
					<div>
						问题描述 我是刚学的,问一个Hibernate的更新方法的问题getHibernateTemplate().update(entity)可以根据entity的主键来更新一个记录,但是如果想要根据条件更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4LvKb.html" rel="bookmark" class="title">innodb monitor</a>
					<div>
						当我们遇到mysql的问题时,我们经常使用show engine innodb status来查看问题 但是很多时候用此命令显示的并不是很全面,我们不得不使用innodb_monitor 来监控数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YVxJb.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;重定向次数过多&rdquo;或者&OpenCurlyDoubleQuote;Too many automatic redirections were attempted&rdquo;的错误：</a>
					<div>
						C# 代码 C# code? 1 2 3 4 5 6 7 8 9 String url=&quot;http://www.google.com.hk/search?hl=zh-CN&amp;q=孟宪会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoPO8M.html" rel="bookmark" class="title">手机端阅读类产品的信息如何架构&quest;</a>
					<div>
						信息架构是产品和用户认知之间的沟通桥梁,是评价一项设计产品的重要标准.本文就以手机端阅读类产品为例谈一点对信息架构的认识和理解. 一.什么是信息架构? 信息架构是在信息环境中,影响系统组织.导览.及分 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
